
(* This allows access to the clipping mask of the room,
   in configuration space (robot's bounding box). *)
signature CLIP =
sig

    type config

    (* For a 3x2 snail robot, horizontal or vertical. *)
    val horiz : config
    val vert : config
    (* for a bullet *)
    val bullet : config
    (* for a star monster *)
    val star : config
    val spider : config
    val rock : config
    val unit : config

    datatype clipobj =
        ClipRoom 
      | ClipRock of Types.rock ref

    (* get the center (offset) of a clip region *)
    val center : config -> int * int
    val clip_width : config -> int

    (* true if the robot cannot inhabit this pixel. *)
    val clipped : Room.room -> Types.rocks -> config -> int * int -> bool
    (* If the robot cannot inhabit this pixel, returns a list of what it's colliding with *)
    val cliplist : Room.room -> Types.rocks -> config -> int * int -> clipobj list

end
