
structure Raytrace =
struct

  type coord = int * int

  val sqr = fn r => r * r
  val sqrReal: real -> real = fn r => r * r
  fun distance (x,y) = Real.Math.sqrt (Real.fromInt (sqr x + sqr y))
  fun diff p0 p1 : int * int = Pair.map2 (fn (v0,v1) => v1 - v0) p0 p1
  fun distPt p0 p1 = distance (diff p0 p1)

  fun raytrace (clipmask,lights,p) =
    let
        fun lightFn p (pLt,v) =
          let val dist = distPt p pLt
              fun isEmpty1 (x,y) = Array2.sub (clipmask, x, y)
              val reaches = Linereal.all isEmpty1 p pLt
          in if reaches then SOME (pLt, v, dist) else NONE end

        fun lightsFn p = List.mapPartial (lightFn p) lights
    in
        lightsFn p
    end

end
