structure Slime =
  struct
    open Types
    open Tile

    (* canonize : dir -> mask -> dir -> dir option *)
    (* canonize orientation tile intention = intention' *)
    fun canonize DOWN  m          RIGHT = SOME RIGHT
      | canonize DOWN  m          LEFT  = SOME LEFT
      | canonize DOWN  (MRAMP s)  UP    = if increasing s
                                           then SOME RIGHT
                                           else SOME LEFT
      | canonize DOWN  m          UP    = NONE
      | canonize DOWN  m          DOWN  = NONE

      | canonize UP    m          RIGHT = SOME RIGHT
      | canonize UP    m          LEFT  = SOME LEFT
      | canonize UP    (MRAMP s)  DOWN  = if increasing s  (* XXX which way? *)
                                           then SOME RIGHT
                                           else SOME LEFT
      | canonize UP    m          DOWN  = NONE
      | canonize UP    m          UP    = NONE

      | canonize RIGHT m          UP    = SOME UP
      | canonize RIGHT m          DOWN  = SOME DOWN
      | canonize RIGHT (MRAMP s)  LEFT  = if increasing s
                                           then SOME UP
                                           else SOME DOWN
      | canonize RIGHT m          LEFT  = NONE
      | canonize RIGHT m          RIGHT = NONE

      | canonize LEFT  m          UP    = SOME UP
      | canonize LEFT  m          DOWN  = SOME DOWN
      | canonize LEFT  (MRAMP s)  RIGHT = if increasing s
                                            then SOME UP
                                            else SOME DOWN
      | canonize LEFT  m          RIGHT = NONE
      | canonize LEFT  m          LEFT  = NONE


    and increasing LM = true
      | increasing MH = true
      | increasing HM = false
      | increasing ML = false
(*
    (* need room *)
    fun clipAt (x, y) =
        Tile.clipmask (Room.maskat (!room, x div TILEW, y div TILEH))
                      (x mod TILEW, y mod TILEH)

    type pos = int * int

    fun assert b = if b then () else raise Fail "pixel invariant violation?"

    fun try3 [p1, p2, p3] =
        if      clipAt p1 then SOME p1
        else if clipAt p2 then SOME p2
        else if clipAt p3 then SOME p3
        else NONE (* slime fell off the wall :( *)
      | try3 _ = raise Fail "You have to give a string"

    fun offset ((x, y), d, int, s) =
        let
            val (dx, dy) = to_vector d
            val (ix, iy) = to_vector int
        in
            (x + dx * s + ix, y + dy * s + iy)
        end
 
    fun proposeCandidate (p, d) int =
        try3 (map (fn s => offset (p, d, int, s)) [~1, 0, 1])

    fun getAngle (x, y, d) = raise Match
 

    fun resolveTransition (p1, d) p2 = 
        let val a1 = getAngle p1
            val a2 = getAngle p2
        in
raise Fail "you have to put a function here"
end

    (* progressSlime : pos * dir -> dir -> (pos * dir) option
        XXX needs an orientation as well?
        progressSlime d (x, y) = SOME (d', (x', y')) iff we moved successfully,
                               = NONE iff we can't -- corner too pointy,
                                                      or we're stuck
        progressSlime returns an orientation for the snail because it
        needs to take care of the flip, due to canonization. *)
    fun progressSlime ((x, y), d) intent =
        case proposeCandidate ((x, y), d) intent of
            SOME p => if sameTile((x, y), p) 
                      then if canWalk d then SOME (p, d) else raise Fail "you have to put a make here here"
                      else resolveTransition ((x,y),d) p
          | NONE => NONE
*)
  end
