
(* Unusually, this just parses the command line during initialization
   so that some global flags are available, mainly for dev purposes.
   This makes it impossible for later code to define flags, FYI. 
   Define them here. *)
structure Args =
struct

    (* for game *)
    val width = Params.param "800" (SOME ("-width", 
                                          "Screen width.")) "width"
        
    val height = Params.param "600" (SOME ("-height", 
                                           "Screen height.")) "height"

    val world = Params.param "world.txt" (SOME ("-world",
                                                "Filename for world.")) "world"

    (* for lightmap *)
    val render = Params.param "all" (SOME ("-render",
                                           "Room to render.")) "render"

    exception Done
    val () = 
        case Params.docommandline () of
            nil => ()
          | _ =>
                let in
                    print "This program does not take any arguments.\n";
                    print "usage:\n";
                    print (Params.usage ());
                    raise Done
                end
end
