structure Offline =
struct
(*  val lights = [((0,0), Tile.lightcolor Tile.LRED)]*)

  (* (int * int) * Tile.prop * real -> Word8.word *)
  fun light_eqn lights =
    let val n = Int.min (15, List.length lights)
        val alpha = Word8.fromInt n * 0wx11
    in (0wxFF, 0wxFF, 0wxFF, alpha)
    end

  fun mk_rgba (room,lights) p =
    if not (Clip.clipped room Clip.unit p)
    then
        let val lights' = Raytrace.raytrace (room, lights, p)
        in
            light_eqn lights'
        end
    (* clipped pixel, zero opacity *)
    else (0wx00, 0wx00, 0wx00, 0wx00)

  fun lightmap room =
    let
        val lights = Room.prop_filter (fn Tile.PLIGHT _ => true | _ => false) room
val () = print ("|lights|=" ^ Int.toString (List.length lights) ^ "\n")
        val b = Room.render (room, mk_rgba (room,lights))
        val () = print (if b then "OK" else "Fail")
    in () end

  val () =
    let val room = Room.start
        val () = lightmap room
    in () end
end
