
(* Defines some types that are used throughout the code. 
   This should be safely open-able. *)

structure Types =
struct

  datatype dir = UP | DOWN | LEFT | RIGHT
  datatype facing = FLEFT | FRIGHT
  datatype intention =
      I_GO of dir
    | I_JUMP
    | I_BOOST
    | I_SUPERJUMP

  datatype action = 
      Nothing
    | Say of string
    | Cutscene of string
    | PlayMusic of string
    | Free of string

  fun dir_reverse UP = DOWN
    | dir_reverse DOWN = UP
    | dir_reverse LEFT = RIGHT
    | dir_reverse RIGHT = LEFT


  fun to_vector UP = (0, ~1)
    | to_vector DOWN = (0, 1)
    | to_vector LEFT = (~1, 0)
    | to_vector RIGHT = (1, 0)

  fun dir_dx UP = 0
    | dir_dx DOWN = 0
    | dir_dx LEFT = ~1
    | dir_dx RIGHT = 1

  fun dir_dy UP = ~1
    | dir_dy DOWN = 1
    | dir_dy LEFT = 0
    | dir_dy RIGHT = 0

  fun dirtos UP = "UP"
    | dirtos DOWN = "DOWN"
    | dirtos LEFT = "LEFT"
    | dirtos RIGHT = "RIGHT"

  datatype rock = Rock of { x : int, y : int, dx : int, dy : int }
  type rocks = rock ref list
end
